Reformatted and refactored some files

Merge pull request #199 from HyP3r-/refactor
This commit is contained in:
azlux 2022-12-06 14:23:52 +01:00 committed by GitHub
commit 553ebb0cb3
No known key found for this signature in database
GPG Key ID: 4AEE18F83AFDEB23
6 changed files with 131 additions and 125 deletions

View File

@ -19,7 +19,6 @@ new=$(echo $api | grep -Po '"tag_name": "\K.*?(?=")')
# Remove potential leftovers from a previous build # Remove potential leftovers from a previous build
rm -rf "$DESTDIR" "$OUTDIR" rm -rf "$DESTDIR" "$OUTDIR"
## log2ram ## log2ram
# Create directory # Create directory
install -Dm 644 "$STARTDIR/log2ram.service" "$DESTDIR/etc/systemd/system/log2ram.service" install -Dm 644 "$STARTDIR/log2ram.service" "$DESTDIR/etc/systemd/system/log2ram.service"

View File

@ -1,7 +1,13 @@
#!/usr/bin/env sh #!/usr/bin/env sh
systemctl -q is-active log2ram && { echo "ERROR: log2ram service is still running. Please run \"sudo service log2ram stop\" to stop it."; exit 1; } systemctl -q is-active log2ram && {
[ "$(id -u)" -eq 0 ] || { echo "You need to be ROOT (sudo can be used)"; exit 1; } echo "ERROR: log2ram service is still running. Please run \"sudo service log2ram stop\" to stop it."
exit 1
}
[ "$(id -u)" -eq 0 ] || {
echo "You need to be ROOT (sudo can be used)"
exit 1
}
# log2ram # log2ram
mkdir -p /usr/local/bin/ mkdir -p /usr/local/bin/

53
log2ram
View File

@ -9,18 +9,17 @@ fi
LOG_NAME='log2ram.log' LOG_NAME='log2ram.log'
NO_RSYNC=${USE_RSYNC#true} NO_RSYNC=${USE_RSYNC#true}
isSafe () { ## @fn is_safe()
## @brief Check if hdd log exists
is_safe() {
[ -d "$HDD_LOG" ] || echo "ERROR: $HDD_LOG/ doesn't exist! Can't sync." [ -d "$HDD_LOG" ] || echo "ERROR: $HDD_LOG/ doesn't exist! Can't sync."
[ -d "$HDD_LOG" ] || exit 1 [ -d "$HDD_LOG" ] || exit 1
} }
remountOriginal() { ## @fn sync_to_disk()
OPTION="$1" ## @brief Sync memory back to hard disk
mount -o remount,"$OPTION" "$HDD_LOG" sync_to_disk() {
} is_safe
syncToDisk () {
isSafe
if [ -z "${NO_RSYNC}" -a -x "$(command -v rsync)" ]; then if [ -z "${NO_RSYNC}" -a -x "$(command -v rsync)" ]; then
rsync -aXv --inplace --no-whole-file --delete-after "$RAM_LOG"/ "$HDD_LOG"/ 2>&1 | tee -a "$LOG2RAM_LOG" rsync -aXv --inplace --no-whole-file --delete-after "$RAM_LOG"/ "$HDD_LOG"/ 2>&1 | tee -a "$LOG2RAM_LOG"
@ -29,8 +28,10 @@ syncToDisk () {
fi fi
} }
syncFromDisk () { ## @fn sync_from_disk()
isSafe ## @brief Sync hard disk to memory
sync_from_disk() {
is_safe
TP_SIZE=$SIZE TP_SIZE=$SIZE
if [ "$ZL2R" = true ]; then if [ "$ZL2R" = true ]; then
@ -42,7 +43,7 @@ syncFromDisk () {
umount -l "$RAM_LOG"/ umount -l "$RAM_LOG"/
umount -l "$HDD_LOG"/ umount -l "$HDD_LOG"/
if [ "$MAIL" = true ]; then if [ "$MAIL" = true ]; then
echo "LOG2RAM : No place on RAM for \"$HDD_LOG/\" anymore, fallback on the disk" | mail -s 'Log2Ram Error' root; echo "LOG2RAM : No place on RAM for \"$HDD_LOG/\" anymore, fallback on the disk" | mail -s 'Log2Ram Error' root
fi fi
exit 1 exit 1
fi fi
@ -55,19 +56,25 @@ syncFromDisk () {
} }
## @fn wait_for()
## @brief Wait for directory and create test file to make sure the directory exists
## @param param1 path to the directory
wait_for() { wait_for() {
while ! findmnt "$1" > /dev/null; do WAIT_PATH="$1"
while ! findmnt "$WAIT_PATH" >/dev/null; do
sleep 0.1 sleep 0.1
done done
while [ ! -f "$1/log2ram.test" ]; do while [ ! -f "$WAIT_PATH/log2ram.test" ]; do
touch "$1/log2ram.test" touch "$WAIT_PATH/log2ram.test"
sleep 0.1 sleep 0.1
done done
rm "$1/log2ram.test" rm "$WAIT_PATH/log2ram.test"
} }
createZramLogDrive () { ## @fn create_zram_log_drive()
## @brief Create zram log device
create_zram_log_drive() {
# Check Zram Class created # Check Zram Class created
if [ ! -d "/sys/class/zram-control" ]; then if [ ! -d "/sys/class/zram-control" ]; then
modprobe zram modprobe zram
@ -81,10 +88,6 @@ createZramLogDrive () {
mke2fs -t ext4 "/dev/zram${RAM_DEV}" mke2fs -t ext4 "/dev/zram${RAM_DEV}"
} }
make_log_dir () {
[ -d "$HDD_LOG" ] || mkdir "$HDD_LOG"
}
case "$1" in case "$1" in
start) start)
IFS=';' IFS=';'
@ -98,20 +101,20 @@ case "$1" in
HDD_LOG="${PATH_FIRST_PART}/hdd.${PATH_LAST_PART}" HDD_LOG="${PATH_FIRST_PART}/hdd.${PATH_LAST_PART}"
LOG2RAM_LOG="${RAM_LOG}/${LOG_NAME}" LOG2RAM_LOG="${RAM_LOG}/${LOG_NAME}"
make_log_dir [ -d "$HDD_LOG" ] || mkdir "$HDD_LOG"
mount --bind "$RAM_LOG"/ "$HDD_LOG"/ mount --bind "$RAM_LOG"/ "$HDD_LOG"/
mount --make-private "$HDD_LOG"/ mount --make-private "$HDD_LOG"/
wait_for "$HDD_LOG" wait_for "$HDD_LOG"
if [ "$ZL2R" = true ]; then if [ "$ZL2R" = true ]; then
createZramLogDrive create_zram_log_drive
mount -t ext4 -o nosuid,noexec,noatime,nodev,user=log2ram "/dev/zram${RAM_DEV}" "$RAM_LOG"/ mount -t ext4 -o nosuid,noexec,noatime,nodev,user=log2ram "/dev/zram${RAM_DEV}" "$RAM_LOG"/
else else
mount -t tmpfs -o "nosuid,noexec,noatime,nodev,mode=0755,size=${SIZE}" log2ram "$RAM_LOG"/ mount -t tmpfs -o "nosuid,noexec,noatime,nodev,mode=0755,size=${SIZE}" log2ram "$RAM_LOG"/
fi fi
wait_for "$RAM_LOG" wait_for "$RAM_LOG"
syncFromDisk sync_from_disk
done done
exit 0 exit 0
;; ;;
@ -125,7 +128,7 @@ case "$1" in
HDD_LOG="${PATH_FIRST_PART}/hdd.${PATH_LAST_PART}" HDD_LOG="${PATH_FIRST_PART}/hdd.${PATH_LAST_PART}"
LOG2RAM_LOG="${RAM_LOG}/${LOG_NAME}" LOG2RAM_LOG="${RAM_LOG}/${LOG_NAME}"
syncToDisk sync_to_disk
#ZRAM_LOG=$(awk '$2 == "/var/log" {print $1}' /proc/mounts) #ZRAM_LOG=$(awk '$2 == "/var/log" {print $1}' /proc/mounts)
#ZRAM_LOG=$(echo ${ZRAM_LOG} | grep -o -E '[0-9]+') #ZRAM_LOG=$(echo ${ZRAM_LOG} | grep -o -E '[0-9]+')
umount -l "$RAM_LOG"/ umount -l "$RAM_LOG"/
@ -145,7 +148,7 @@ case "$1" in
HDD_LOG="${PATH_FIRST_PART}/hdd.${PATH_LAST_PART}" HDD_LOG="${PATH_FIRST_PART}/hdd.${PATH_LAST_PART}"
LOG2RAM_LOG="${RAM_LOG}/${LOG_NAME}" LOG2RAM_LOG="${RAM_LOG}/${LOG_NAME}"
syncToDisk sync_to_disk
done done
exit 0 exit 0
;; ;;

View File

@ -36,4 +36,3 @@ COMP_ALG=lz4
# lzo/lz4=2.1:1 compression ratio zlib=2.7:1 zstandard=2.9:1 # lzo/lz4=2.1:1 compression ratio zlib=2.7:1 zstandard=2.9:1
# Really a guestimate of a bit bigger than compression ratio whilst minimising 0.1% mem usage of disk size # Really a guestimate of a bit bigger than compression ratio whilst minimising 0.1% mem usage of disk size
LOG_DISK_SIZE=100M LOG_DISK_SIZE=100M

View File

@ -5,8 +5,7 @@ if dpkg -l log2ram 2> /dev/null; then
exit 1 exit 1
fi fi
if [ "$(id -u)" -eq 0 ] if [ "$(id -u)" -eq 0 ]; then
then
echo "Not apt installed. Remove will continue with this script..." echo "Not apt installed. Remove will continue with this script..."
systemctl stop log2ram.service log2ram-daily.timer systemctl stop log2ram.service log2ram-daily.timer
systemctl disable log2ram.service log2ram-daily.timer systemctl disable log2ram.service log2ram-daily.timer